Fix logical structure of config_vmware().
[grml-autoconfig.git] / autoconfig.functions
1 #!/bin/zsh
2 # Filename:      autoconfig.functions
3 # Purpose:       basic system configuration and hardware setup for grml system
4 # Authors:       grml-team (grml.org), (c) Klaus Knopper <knopper@knopper.net>, (c) Michael Prokop <mika@grml.org>
5 # Bug-Reports:   see http://grml.org/bugs/
6 # License:       This file is licensed under the GPL v2.
7 # Latest change: Die Apr 03 17:02:59 CEST 2007 [mika]
8 ################################################################################
9
10 # {{{ path, variables, signals, umask, zsh
11 export PATH="/bin:/sbin:/usr/bin:/usr/sbin:/usr/X11R6/bin"
12 DEBUG="/dev/null"
13 KERNEL="$(uname -r)"
14 umask 022
15
16 # Ignore these signals in non-interactive mode: INT, TERM, SEGV
17 [ -z "$PS1" ] && trap "" 2 3 11
18
19 # zsh stuff
20 iszsh(){
21 if [ -n "$ZSH_VERSION" ] ; then
22   return 0
23 else
24   return 1
25 fi
26 }
27 # avoid 'no matches found: ...'
28 iszsh && setopt no_nomatch # || echo "Warning: not running under zsh!"
29 # }}}
30
31 ### {{{ Utility Functions
32
33 # Simple shell grep
34 stringinfile(){
35   case "$(cat $2)" in *$1*) return 0;; esac
36   return 1
37 }
38
39 # same for strings
40 stringinstring(){
41   case "$2" in *$1*) return 0;; esac
42   return 1
43 }
44
45 # Reread boot command line; echo last parameter's argument or return false.
46 getbootparam(){
47   stringinstring " $1=" "$CMDLINE" || return 1
48   result="${CMDLINE##*$1=}"
49   result="${result%%[   ]*}"
50   echo "$result"
51   return 0
52 }
53
54 # Check boot commandline for specified option
55 checkbootparam(){
56   stringinstring " $1" "$CMDLINE"
57   return "$?"
58 }
59
60 checkvalue(){
61   if [ "$1" = "yes" ] ; then
62     return 0
63   else
64     return 1
65   fi
66 }
67
68 checkgrmlsmall(){
69   grep -q small /etc/grml_version 2>>$DEBUG && return 0 || return 1
70 }
71
72 checkgrmlusb(){
73   grep -q usb /etc/grml_version 2>>$DEBUG && return 0 || return 1
74 }
75 ### }}}
76
77 # {{{ filesystems (proc, pts, sys) and fixes
78 mount_proc(){
79   [ -f /proc/version ] || mount -t proc /proc /proc 2>/dev/null
80 }
81
82 mount_pts(){
83   stringinfile "/dev/pts" /proc/mounts || mount -t devpts /dev/pts /dev/pts 2>/dev/null
84 }
85
86 mount_sys(){
87   [ -d /sys/devices ] || mount -t sysfs /sys /sys 2>/dev/null
88 }
89 # }}}
90
91 # {{{ Read in boot parameters
92 [ -f /proc/version ] || mount_proc # make sure we can access /proc/cmdline when sourcing this file too
93 CMDLINE="$(cat /proc/cmdline)"
94 [ -d /cdrom/bootparams/ ] && CMDLINE="$CMDLINE $(cat /cdrom/bootparams/* | tr '\n' ' ')"
95 # }}}
96
97 # {{{ Check if we are running from the grml-CD or HD
98 INSTALLED=""
99 [ -e /GRML/etc/grml_cd ] || INSTALLED="yes"
100
101 # testcd
102 TESTCD=""
103 checkbootparam "testcd" >>$DEBUG 2>&1 && TESTCD="yes"
104 # }}}
105
106 # {{{ source lsb-functions , color handling
107 if checkbootparam "nocolor"; then
108   RC_NOCOLOR=yes
109   . /etc/grml/lsb-functions
110   einfo "Disabling colors in bootsequence as requested on commandline." ; eend 0
111 else
112   . /etc/grml/lsb-functions
113   . /etc/grml_colors
114 fi
115 # }}}
116
117 # {{{ debug
118 config_debug(){
119  if checkbootparam "debug"; then
120    BOOTDEBUG="yes"
121  fi
122  if stringinstring "BOOT_IMAGE=debug " "$CMDLINE" ; then
123    BOOTDEBUG="yes"
124  fi
125  rundebugshell(){
126   if [ -n "$BOOTDEBUG" ]; then
127     einfo "Starting intermediate shell stage $stage as requested by \"debug\" option."
128     eindent
129     if [ -r /etc/grml/screenrc ] ; then
130        einfo "Starting GNU screen to be able to use a full featured shell environment."
131        einfo "Just exit the shells (and therefore screen) to continue boot process..."
132        /bin/zsh -c "screen -c /etc/grml/screenrc"
133     else
134       einfo "Notice that the shell does not provide job handling: ctrl-z, bg and fg won't work!"
135       einfo "Just exit the shell to continue boot process..."
136       /bin/zsh
137     fi
138     eoutdent
139   fi
140  }
141 }
142 # }}}
143
144 # {{{ log
145 config_log(){
146 if checkbootparam "log"; then
147   export DEBUG="/tmp/grml.log.`date +%Y%m%d`"
148   touch $DEBUG
149   einfo "Bootparameter log found. Log files: ${DEBUG} and /var/log/boot."
150   eindent
151     einfo "Starting bootlogd."
152     bootlogd -r -c 1>>$DEBUG 2>&1 ; eend $?
153   eoutdent
154 else
155   DEBUG="/dev/null"
156 fi
157 }
158 # }}}
159
160 # {{{ Check if we are in interactive startup mode
161 INTERACTIVE=""
162 stringinstring "BOOT_IMAGE=expert " "$CMDLINE" && INTERACTIVE="yes"
163 # }}}
164
165 # {{{ set firmware timeout via bootparam
166 config_fwtimeout(){
167  if checkbootparam fwtimeout ; then
168    TIMEOUT="$(getbootparam 'fwtimeout' 2>>$DEBUG)"
169    einfo "Bootoption fwtimeout found. (Re)Loading firmware_class module."
170    rmmod firmware_class 1>>$DEBUG 2>&1
171    modprobe firmware_class ; eend $?
172  fi
173  if [ -z "$TIMEOUT" ] ; then
174    TIMEOUT="100" # linux kernel default: 10
175  fi
176  if [ -f /sys/class/firmware/timeout ] ; then
177    einfo "Setting timeout for firmware loading to ${TIMEOUT}."
178    echo 100 > /sys/class/firmware/timeout ; eend $?
179  fi
180 }
181 # }}}
182
183 ### {{{ language configuration / localization
184 config_language(){
185
186  einfo "Activating language settings:"
187  eindent
188
189  # people can specify $LANGUAGE and $CONSOLEFONT in a config file:
190  [ -r /etc/grml/autoconfig ] && . /etc/grml/autoconfig
191
192  grep -q ' lang=.*-utf8' /proc/cmdline && UTF8='yes' || UTF8=''
193
194  # check for bootoption which overrides config from /etc/grml/autoconfig:
195  BOOT_LANGUAGE="$(getbootparam lang 2>>$DEBUG)"
196  [ -n "$BOOT_LANGUAGE" ] && LANGUAGE="$BOOT_LANGUAGE"
197
198  # set default to 'en' in live-cd mode if $LANGUAGE is not yet set:
199  if [ -z "$INSTALLED" ] ; then
200     [ -n "$LANGUAGE" ] || LANGUAGE='en-utf8'
201  fi
202
203  # if bootoption lang is used update /etc/default/locale, otherwise *not*!
204  if [ -n "$BOOT_LANGUAGE" ] ; then
205     [ -x /usr/sbin/grml-setlang ] && /usr/sbin/grml-setlang "$LANGUAGE"
206  fi
207
208  # set console font
209  if [ -z "$CONSOLEFONT" ] ; then
210     if ! checkbootparam "nodefaultfont" >>$DEBUG 2>&1 ; then
211        # [ -n "$UTF8" ] && CONSOLEFONT='LatArCyrHeb-16' || CONSOLEFONT='Lat15-Terminus16'
212        # if [ -r /usr/share/consolefonts/Lat15-Terminus16.psf.gz ] ; then
213        if [ -r /usr/share/consolefonts/Uni3-Terminus16.psf.gz ] ; then
214           CONSOLEFONT='Uni3-Terminus16'
215        else
216           ewarn "/usr/share/consolefonts/Uni3-Terminus16.psf.gz not available. Please upgrade package console-terminus." ; eend 1
217        fi
218     fi
219  fi
220
221  # export it now, so error messages get translated, too
222  if checkgrmlsmall ; then
223     export LANG='C' # grml-small does not provide any further locales
224  else
225     [ -r /etc/default/locale ] && . /etc/default/locale
226     export LANG LANGUAGE
227  fi
228
229  # configure keyboard layout, read in already set values first:
230  [ -r /etc/sysconfig/keyboard ] && . /etc/sysconfig/keyboard
231
232  # now allow keyboard override by boot commandline for later use:
233  KKEYBOARD="$(getbootparam keyboard 2>>$DEBUG)"
234  [ -n "$KKEYBOARD" ] && KEYTABLE="$KKEYBOARD"
235  # notce: de/at is a bad choice, so take de-latin1-nodeadkeys instead:
236  [[ "$KKEYBOARD" == 'de' ]] && KEYTABLE=de-latin1-nodeadkeys
237  [[ "$KKEYBOARD" == 'at' ]] && KEYTABLE=de-latin1-nodeadkeys
238
239  # modify /etc/sysconfig/keyboard only in live-cd mode:
240  if [ -z "$INSTALLED" ] ; then
241
242    local LANGUAGE="$BOOT_LANGUAGE"
243    . /etc/grml/language-functions
244    # allow setting xkeyboard explicitly different than console keyboard
245    KXKEYBOARD="$(getbootparam xkeyboard 2>>$DEBUG)"
246    if [ -n "$KXKEYBOARD" ]; then
247       XKEYBOARD="$KXKEYBOARD"
248       KDEKEYBOARD="$KXKEYBOARD"
249    elif [ -n "$KKEYBOARD" ]; then
250       XKEYBOARD="$KKEYBOARD"
251       KDEKEYBOARD="$KKEYBOARD"
252    fi
253
254    # duplicate of previous code to make sure /etc/grml/language-functions
255    # does not overwrite our values....
256    # now allow keyboard override by boot commandline for later use:
257    KKEYBOARD="$(getbootparam keyboard 2>>$DEBUG)"
258    [ -n "$KKEYBOARD" ] && KEYTABLE="$KKEYBOARD"
259    # notce: de/at is a bad choice, so take de-latin1-nodeadkeys instead:
260    [[ "$KKEYBOARD" == 'de' ]] && KEYTABLE=de-latin1-nodeadkeys
261    [[ "$KKEYBOARD" == 'at' ]] && KEYTABLE=de-latin1-nodeadkeys
262
263    # write keyboard related variables to file for later use
264    [ -d /etc/sysconfig ] || mkdir /etc/sysconfig
265    echo "KEYTABLE=\"$KEYTABLE\""          > /etc/sysconfig/keyboard
266    echo "XKEYBOARD=\"$XKEYBOARD\""       >> /etc/sysconfig/keyboard
267    echo "KDEKEYBOARD=\"$KDEKEYBOARD\""   >> /etc/sysconfig/keyboard
268    echo "KDEKEYBOARDS=\"$KDEKEYBOARDS\"" >> /etc/sysconfig/keyboard
269  fi
270
271  [ -r /etc/sysconfig/keyboard ] && . /etc/sysconfig/keyboard
272
273  # activate unicode console if running within utf8 environment
274  if [ -r /etc/default/locale ] ; then
275     if grep -q "LANG=.*UTF" /etc/default/locale ; then
276        einfo "Setting up unicode environment."
277        unicode_start
278        eend $?
279     fi
280  fi
281
282  # Set default keyboard before interactive setup
283  if [ -n "$KEYTABLE" ] ; then
284   einfo "Running loadkeys for ${WHITE}${KEYTABLE}${NORMAL} in background"
285   loadkeys -q $KEYTABLE &
286   eend $?
287  fi
288
289  # we have to set up all consoles, therefore loop it over all ttys:
290  NUM_CONSOLES=`fgconsole --next-available`
291  NUM_CONSOLES=`expr ${NUM_CONSOLES} - 1`
292  [ ${NUM_CONSOLES} -eq 1 ] && NUM_CONSOLES=6
293  if [ -n "$CHARMAP" ] ; then
294     einfo "Running consolechars for ${CHARMAP}"
295     for vc in `seq 0 ${NUM_CONSOLES}`  ; do
296         consolechars --tty=/dev/tty${vc} -m ${CHARMAP} ; RC=$?
297     done
298     eend $RC
299  fi
300  if [ -n "$CONSOLEFONT" ] ; then
301     einfo "Running consolechars using ${CONSOLEFONT}"
302     for vc in `seq 0 ${NUM_CONSOLES}`  ; do
303         consolechars --tty=/dev/tty${vc} -f $CONSOLEFONT || consolechars --tty=/dev/tty${vc} -d
304     done
305     eend $?
306  fi
307
308  eoutdent
309 }
310 # }}}
311
312 # {{{ Set hostname
313 config_hostname(){
314  if checkbootparam hostname ; then
315   HOSTNAME="$(getbootparam 'hostname' 2>>$DEBUG)"
316   einfo "Setting hostname to $HOSTNAME as requested."
317   sed -i "s/^127.0.0.1.*localhost/127.0.0.1 $HOSTNAME localhost/" /etc/hosts
318   hostname $HOSTNAME ; eend $?
319  else
320   hostname --file /etc/hostname
321  fi
322 }
323 # }}}
324
325 # fstabuser (needed when running from harddisk with username != grml {{{
326 config_userfstab(){
327   [ -r /etc/grml/autoconfig ] && . /etc/grml/autoconfig
328   if [ -n "$CONFIG_FSTAB_USER" ] ; then
329      fstabuser="$CONFIG_FSTAB_USER"
330   else
331      fstabuser=$(getent passwd 1000 | cut -d: -f1)
332   fi
333   # if not yet set fall back to default 'grml' user
334   [ -n "$fstabuser" ] || fstabuser='grml'
335 }
336 # }}}
337
338 # {{{ Set clock (Local time is more often used than GMT, so it is default)
339 config_time(){
340  # don't touch the files if running from harddisk:
341  if [ -z "$INSTALLED" ]; then
342     UTC=""
343     checkbootparam utc >>$DEBUG 2>&1 && UTC="-u"
344     checkbootparam gmt >>$DEBUG 2>&1 && UTC="-u"
345     # hwclock uses the TZ variable
346     [ -r /etc/timezone ] && TZ=$(cat /etc/timezone)
347     [ -n "$TZ" ] || TZ=Europe/Vienna
348
349     if ! [ -r /dev/rtc ] ; then
350       ewarn "Realtime clock not available, skipping execution of hwclock therefore." ; eend 0
351     else
352       ERROR=$(TZ="$TZ" hwclock $UTC -s 2>&1 | head -1) ; RC=$?
353       if [ -n "$ERROR" ] ; then
354          eindent
355          ERROR=$(TZ="$TZ" hwclock $UTC -s --directisa 2>&1 | head -1)
356          if [ -n "$ERROR" ] ; then
357             eerror "Problem running hwclock: $ERROR" ; eend 1
358          fi
359          eoutdent
360       fi
361     fi
362  fi
363 }
364 # }}}
365
366 # {{{ print kernel info
367 config_kernel(){
368   vmware-detect &>/dev/null && VMWARE="inside ${WHITE}VMware/Qemu${NORMAL}"
369   [ -d /proc/xen ] && VMWARE='' # vmware-detect returns '0' when running with a Xen-enabled kernel
370   einfo "Running Linux Kernel $KERNEL $VMWARE" ; eend 0
371   if [ -r /proc/cpuinfo ] ; then
372      if egrep -q '^flags.*(vmx|svm)' /proc/cpuinfo ; then
373        eindent
374        einfo 'CPU(s) featuring virtualization technology detected' ; eend 0
375        eoutdent
376      fi
377   fi
378   if [ -d /proc/xen ] ; then
379      eindent
380      einfo 'Running kernel featuring support for Xen detected' ; eend 0
381      eoutdent
382   fi
383 }
384 # }}}
385
386 # {{{ vmware specific stuff
387 config_vmware(){
388 if checkbootparam novmware ; then
389    ewarn "Skipping running vmware specific stuff as requested on boot commandline." ; eend 0
390 else
391    if [ -z "$INSTALLED" ] ; then
392       if vmware-detect || stringinstring "BOOT_IMAGE=vmware " "$CMDLINE" ; then
393               if ! checkbootparam qemu ; then
394             if [ -r /etc/X11/xorg.conf.vmware ] ; then
395                einfo "VMware: Copying /etc/X11/xorg.conf.vmware to /etc/X11/xorg.conf"
396                cp /etc/X11/xorg.conf.vmware /etc/X11/xorg.conf ; eend $?
397             fi
398          fi
399       fi
400    fi
401 fi
402 }
403 # }}}
404
405 # {{{ qemu specific stuff
406 config_qemu(){
407 if checkbootparam qemu ; then
408    if [ -r /etc/X11/xorg.conf.example ] ; then
409       einfo "Qemu: Copying /etc/X11/xorg.conf.example to /etc/X11/xorg.conf"
410       cp /etc/X11/xorg.conf.example /etc/X11/xorg.conf ; eend $?
411    fi
412 fi
413 }
414 # }}}
415
416 # {{{ ld.so.cache + depmod
417 config_ld_mod(){
418 if [ -n "$INSTALLED" ]; then
419  if ! [ -r /etc/grml.first.boot ] ; then
420   einfo "Running from HD for the first time, regenerate ld.so.cache and modules.dep:"
421   eindent
422 # Regenerate ld.so.cache and module dependencies on HD
423     einfo "Running ldconfig" ; ldconfig  ; eend $?
424     einfo "Running depmod"   ; depmod -a ; eend $?
425     touch /etc/grml.first.boot
426     eend 0
427   eoutdent
428  fi
429 fi
430 }
431 # }}}
432
433 # update_progress {{{
434 update_progress(){
435   # be sure we are non-blocking
436   (echo "$1" > /etc/sysconfig/progress) &
437 }
438 # }}}
439
440 # {{{ timezone
441 config_timezone(){
442  # don't touch the files if running from harddisk:
443  if [ -z "$INSTALLED" ]; then
444   einfo "Setting timezone."
445   KTZ="$(getbootparam tz 2>>$DEBUG)"
446   [ -f "/usr/share/zoneinfo/$KTZ" ] && TZ="$KTZ"
447   rm -f /etc/localtime
448   cp "/usr/share/zoneinfo/$TZ" /etc/localtime && eend 0
449  fi
450 }
451 # }}}
452
453 # small computer / nearly no ram {{{
454 config_small(){
455
456 RAM=$(/usr/bin/gawk '/MemTotal/{print $2}' /proc/meminfo)
457 # MEM=$(/usr/bin/gawk 'BEGIN{m=0};/MemFree|Cached|SwapFree/{m+=$2};END{print m}' /proc/meminfo)
458 eindent
459
460 if checkbootparam "small"; then
461   einfo "Information: ${RAM} kB of RAM available." ; eend 0
462   einfo "Bootoption small detected. Activating small system."
463   if [ -r /etc/inittab.small ] ; then
464     mv /etc/inittab /etc/inittab.normal
465     mv /etc/inittab.small /etc/inittab
466   else
467     sed -i 's/^9/#&/' /etc/inittab
468     sed -i 's/^10/#&/' /etc/inittab
469     sed -i 's/^11/#&/' /etc/inittab
470     sed -i 's/^12/#&/' /etc/inittab
471   fi
472   /sbin/telinit q ; eend $?
473 else
474   if checkgrmlsmall ; then
475     if [[ $RAM -lt 25000 ]] ; then
476       ewarn "Information: ${RAM} kB of RAM available." ; eend 1
477       ewarn "At least 32MB of RAM should be available for grml-small." ; eend 1
478       ewarn "Use the bootoption small to save some more MB of memory usage." ; eend 0
479       ewarn "Dropping you into a rescue shell. To continue booting exit the shell." ; eend 0
480       /bin/zsh --login
481     else
482       einfo "Information: ${RAM} kB of RAM available." ; eend 0
483     fi
484   else
485     if [[ $RAM -lt 58000 ]] ; then
486       ewarn "Information: ${RAM} kB of RAM available." ; eend 1
487       ewarn "At least 64MB of RAM should be available for grml." ; eend 1
488       ewarn "Use the bootoption small to save some more MB of memory usage." ; eend 0
489       ewarn "Dropping you into a rescue shell. To continue booting exit the shell." ; eend 0
490       /bin/zsh --login
491     else
492       einfo "Information: ${RAM} kB of RAM available." ; eend 0
493     fi
494   fi
495 fi
496 eoutdent
497 }
498 # }}}
499
500 # skip startup of w3m {{{
501 config_fast(){
502 if checkbootparam "fast"; then
503   ewarn "Bootoption fast detected. Skipping startup of w3m."
504     sed -i 's#^1:.*#1:12345:respawn:/usr/bin/openvt -f -c 1 -w -- /bin/zsh#' /etc/inittab
505   /sbin/telinit q ; eend $?
506 fi
507 }
508 # }}}
509
510 # activate serial console {{{
511 config_console(){
512 if checkbootparam "console"; then
513   einfo "Bootoption (for serial) console detected."
514   eindent
515     if [ -r /etc/mgetty/mgetty.config ] ; then
516        MODE=$(getbootparam console | awk -F, '{print $2}')
517        MODE=${MODE%%n*}
518        [ -n "$MODE" ] || MODE=9600 # default mode
519        einfo "Setting speed in /etc/mgetty/mgetty.config to $MODE bps"
520        sed -i "s/speed [0-9]*/speed $MODE/" /etc/mgetty/mgetty.config ; eend $?
521     fi
522
523     einfo "Activating mgetty."
524     sed -i 's/^#T0/T0/' /etc/inittab
525     sed -i 's/^#T1/T1/' /etc/inittab
526     /sbin/telinit q ; eend $?
527   eoutdent
528 fi
529 }
530 # }}}
531
532 # For burning on IDE-CD-Roms, k3b (and others) check for special permissions {{{
533 config_cdrom_perm(){
534 CDROMS=""
535 for DEVICE in /proc/ide/hd?; do
536  [ "$(cat $DEVICE/media 2>/dev/null)" = "cdrom" ] && CDROMS="$CDROMS /dev/${DEVICE##*/}"
537 done
538 [ -n "$CDROMS" ] && { chown root.cdrom $CDROMS; chmod 666 $CDROMS; } 2>/dev/null
539 }
540 # }}}
541
542 # {{{ Bring up loopback interface now
543 config_local_net(){
544  if [ -z "$INSTALLED" ] ; then
545     if grep -q 'iface lo inet loopback' /etc/network/interfaces 2>/dev/null ; then
546        grep -q lo=lo /etc/network/run/ifstate 2>/dev/null || ifup lo
547     else
548        ifconfig lo up
549     fi
550  fi
551 }
552 # }}}
553
554 # firewire devices {{{
555 # the raw1394 driver does not yet export info into SYSFS,
556 # so let's create raw1394 device manually
557 # http://www.michael-prokop.at/blog/index.php?p=352
558 config_firewire_dev(){
559 if checkbootparam "nofirewiredev" ; then
560   ewarn "Skipping creating some firewire devices as requested on boot commandline." ; eend 0
561 else
562 #if [ "${KERNEL%-*}" == "2.6.11" ] ; then
563   einfo "Creating some firewire devices (fix kernel 2.6-bug)."
564 #  cd /dev && MAKEDEV video1394 raw1394
565   [ -r /dev/raw1394 ]   || mknod /dev/raw1394 c 171 0
566   [ -r /dev/video1394 ] || mknod -m 666 /dev/video1394 c 171 16
567 # mknod -m 666 /dev/dv1394 c 171 32 # for NTSC
568   [ -r /dev/dv1394 ]    || mknod -m 666 /dev/dv1394 c 171 34 # for PAL
569   chown -R root:video /dev/raw1394 /dev/video1394 /dev/dv1394
570   chmod -R 664 /dev/raw1394 /dev/video1394 /dev/dv1394 ; eend $?
571 fi
572 #fi
573 }
574 # }}}
575
576 # {{{ copy passwd-lockfile to ramdisk (fix unionfs-behaviour)
577 # otherwise we will get: passwd: Authentication token lock busy
578 config_fix_passwd(){
579  if [ -z "$INSTALLED" ] ; then
580   touch /etc/.pwd.lock
581  fi
582 }
583 # }}}
584
585 # {{{ CD Checker
586 config_testcd(){
587 if [ -n "$TESTCD" ]; then
588   einfo "Checking CD data integrity as requested by '${WHITE}testcd${NORMAL}' boot option."
589   einfo "Reading files and checking against GRML/md5sums, this may take a while..."
590   echo -n "${RED}"
591   ( cd /cdrom/GRML/ ; rm -f /tmp/md5sum.log ; md5sum -c md5sums 2>&1 | tee /tmp/md5sum.log )
592   if [ "$?" = "0" ]; then
593     echo " ${GREEN}Everything looks OK${NORMAL}"
594     else
595     echo "${RED} *** CHECKSUM FAILED FOR THESE FILES:                          ***"
596     egrep -v '(^md5sum:|OK$)' /tmp/md5sum.log
597     echo "${RED} *** DATA ON YOUR CD MEDIUM IS POSSIBLY INCOMPLETE OR DAMAGED, ***${NORMAL}"
598     echo "${RED} *** OR YOUR COMPUTER HAS BAD RAM.                             ***${NORMAL}"
599     echo -n "${CYAN}Hit return to contine, or press the reset button to quit.${NORMAL}\a\a\a "
600     read a
601   fi
602   eend 0
603 fi
604 }
605 # }}}
606
607 # {{{ hardware detection via discover
608 config_discover(){
609 if checkbootparam "nodisc" ; then
610   ewarn "Skipping hardware detection via discover as requested on boot commandline." ; eend 0
611 else
612  if [ -x /sbin/discover ] ; then
613   einfo "Discovering hardware. Trying to load the following modules in background:"
614    eindent
615    einfo "$(discover --data-path=linux/module/name --data-path=linux/modules/options --format="%s %s" --data-version=`uname -r` --enable-bus all | sort -u | xargs echo)"
616    eoutdent
617   /sbin/discover-modprobe -v 1>>$DEBUG 2>&1 &
618   eend 0
619  else
620   eerror "Application discover not available. Information: udev should handle hardware recognition." ; eend 0
621  fi
622 fi
623 }
624 # }}}
625
626 # {{{ hardware detection via hwinfo
627 config_hwinfo(){
628 if checkbootparam hwinfo >>$DEBUG 2>&1; then
629   einfo "Discovering hardware via hwinfo:"
630   MODULES=$(su grml hwinfo | grep "Cmd: \"modprobe" | awk '{print $5}' | sed 's/"//')
631   echo -n "  Loading modules: "
632   for i in `echo $MODULES` ; do echo -n $i && modprobe $i ; done
633   eend 0
634 fi
635 }
636 # }}}
637
638 # {{{ disable hotplug agents on request
639 config_hotplug_agent(){
640 if checkbootparam "noagent" ; then
641   AGENT="$(getbootparam 'noagent' 2>>$DEBUG)"
642   AGENTLIST=$(echo "$AGENT" | sed 's/,/\\n/g')
643   AGENTNL=$(echo "$AGENT" | sed 's/,/ /g')
644   einfo "Disabling hotplug-agent(s) $AGENTNL"
645   for agent in $(echo -e $AGENTLIST) ; do
646     mv /etc/hotplug/${agent}.rc /etc/hotplug/${agent}.norc
647   done
648   [ "$?" == "0" ] ; eend $?
649 fi
650 }
651 # }}}
652
653 # {{{ blacklist of hotplug-modules
654 config_hotplug_blacklist(){
655 if checkbootparam "black" ; then
656   BLACK="$(getbootparam 'black' 2>>$DEBUG)"
657   BLACKLIST=$(echo "$BLACK" | sed 's/,/\\n/g')
658   BLACKNL=$(echo "$BLACK" | sed 's/,/ /g')
659   einfo "Blacklisting $BLACKNL via /etc/hotplug/blacklist.d/hotplug-light"
660   echo -e "$BLACKLIST" >> /etc/hotplug/blacklist.d/hotplug-light
661   echo -e "$BLACKLIST" >> /etc/hotplug/blacklist
662   eend 0
663 fi
664 }
665 # }}}
666
667 # {{{ run hotplug
668 config_hotplug(){
669 if checkbootparam "nohotplug" ; then
670   ewarn "Skipping running hotplug as requested on boot commandline." ; eend 0
671 else
672   if [ -r /etc/init.d/hotplug ] ; then
673     einfo "Starting hotplug system in background."
674     /etc/init.d/hotplug start 1>>$DEBUG 2>>$DEBUG &
675     eend 0
676   elif [ -r /etc/init.d/hotplug-light ] ; then
677     einfo "Starting hotplug-light system in background."
678     /etc/init.d/hotplug-light start 1>>$DEBUG 2>>$DEBUG &
679     eend 0
680   else
681     ewarn "No hotplug system found. Should be handled by udev. Skipping execution." ; eend 0
682   fi
683 fi
684 }
685 # }}}
686
687 # {{{ blacklist specific module [ used in /etc/init.d/udev ]
688 config_blacklist(){
689 if checkbootparam "blacklist" ; then
690  if [ -z "$INSTALLED" ]; then
691   einfo "Bootoption blacklist found."
692   BLACK="$(getbootparam 'blacklist' 2>>$DEBUG)"
693   if [ -n "$BLACK" ] ; then
694     einfo "Blacklisting module ${BLACK} via /etc/modprobe.d/grml."
695     echo "# begin entry generated by config_blacklist of grml-autoconfig" >> /etc/modprobe.d/grml
696     echo "blacklist $BLACK"     >> /etc/modprobe.d/grml
697     echo "alias     $BLACK off" >> /etc/modprobe.d/grml
698     echo "# end   entry generated by config_blacklist of grml-autoconfig" >> /etc/modprobe.d/grml ; eend $?
699   else
700    eerror "No given module for blacklist found. Blacklisting will not work therefor."
701   fi
702  else
703   ewarn "Backlisting via bootoption does not work on harddisk installations." ; eend 1
704   eindent
705    einfo "Please blacklist the module(s) via /etc/modprobe.d/blacklist."
706   eoutdent
707  fi
708 fi
709 }
710 # }}}
711
712 # {{{ ACPI
713 config_acpi_apm(){
714 if [ -d /proc/acpi ]; then
715   if checkbootparam "noacpi"; then
716     ewarn "Skipping ACPI Bios detection as requested on boot commandline." ; eend 0
717   else
718     einfo "ACPI Bios found, activating modules: "
719     eindent
720     found=""
721     for a in /lib/modules/$KERNEL/kernel/drivers/acpi/*; do
722       basename="${a##*/}"
723       basename="${basename%%.*}"
724       case "$basename" in *_acpi)
725        egrep -qi "${basename%%_acpi}" /proc/acpi/dsdt 2>>$DEBUG || continue ;;
726       esac
727       modprobe $basename >>$DEBUG 2>&1 && found="yes"
728       local BASE="$BASE $basename"
729     done
730     if [ -n "$found" ] ; then
731       einfo "$BASE"  ; eend 0
732     else
733       ewarn "(none)" ; eend 1
734     fi
735     if ! [ -S /var/run/acpid.socket ] ; then
736       if ! [ -r /var/run/dbus/pid ] ; then
737         einfo "Starting acpi daemon."
738         /etc/init.d/acpid start >>$DEBUG ; eend $?
739       else
740         eerror "acpid error: it seems you are running d-bus/hal, but acpid needs to be started before d-bus."
741         eerror "Solution: please activate acpid via /etc/runlevel.conf"
742         eend 1
743       fi
744     else
745       ewarn "acpi daemon already running."
746       eend 0
747     fi
748     eoutdent
749   fi
750 else
751 # APM
752   if checkbootparam "noapm"; then
753     ewarn "Skipping APM Bios detection as requested on boot commandline." ; eend 0
754   else
755     modprobe apm power_off=1 >>$DEBUG 2>&1
756     if [ "$?" = "0" ] ; then
757        if [ -x /etc/init.d/apmd ] ;then
758           einfo "APM Bios found, enabling power management functions."
759           /etc/init.d/apmd start ; eend $?
760        fi
761     else
762       eerror "Loading apm module failed." ; eend 1
763     fi
764   fi
765 fi
766 }
767 # }}}
768
769 # {{{ PCMCIA Check/Setup
770 # This needs to be done before other modules are being loaded (by hwsetup)
771 config_pcmcia(){
772 if checkbootparam "nopcmcia"; then
773   ewarn "Skipping PCMCIA detection as requested on boot commandline." ; eend 0
774 else
775   if /usr/sbin/laptop-detect ; then
776     einfo "Detected Laptop - checking for PCMCIA." && eend 0
777     modprobe pcmcia_core >>$DEBUG 2>&1
778     # Try Cardbus or normal PCMCIA socket drivers
779     modprobe yenta_socket >>$DEBUG 2>&1 || modprobe i82365 >>$DEBUG 2>&1 || modprobe pd6729 >>$DEBUG 2>&1 || modprobe tcic >>$DEBUG 2>&1
780     if [ "$?" = "0" ]; then
781       modprobe ds >>$DEBUG 2>&1
782       if [ -d /proc/bus/pccard ] ; then
783        if [ -x /sbin/cardmgr ] ; then
784         einfo "PCMCIA found, starting cardmgr."
785         cardmgr >>$DEBUG 2>&1 && sleep 6 && eend 0
786        else
787         eerror "No cardmgr found. Make sure package pcmciautils is installed, it should handle it instead." ; eend 1
788        fi
789       fi
790     fi
791   fi
792 fi
793 }
794 # }}}
795
796 # {{{ run software synthesizer via speakup
797 config_swspeak(){
798 if checkbootparam swspeak ; then
799  if [ -d /proc/speakup/ ] ; then
800   einfo "Bootoption swspeak found. Kernel supports speakup." ; eend 0
801   eindent
802    if [ -x /etc/init.d/speech-dispatcher ] ; then
803      einfo "Starting speech-dispatcher."
804      /etc/init.d/speech-dispatcher start 1>>DEBUG ; eend $?
805      einfo "Activating sftsyn in Kernel."
806      echo sftsyn >/proc/speakup/synth_name ; eend $?
807      einfo "Just run swspeak if you want to use software synthesizer via speakup."
808      flite -o play -t "Finished activating software speakup. Just run swspeak when booting finished."
809    else
810     eerror "speech-dispatcher not available. swspeak will not work without it." ; eend 1
811     flite -o play -t "speech-dispatcher not available. speakup will not work without it."
812    fi
813   eoutdent
814  else
815   eerror "Kernel does not seem to support speakup. Skipping swspeak." ; eend 1
816   flite -o play -t "Kernel does not seem to support speakup. Sorry."
817  fi
818 fi
819 }
820 # }}}
821
822 # {{{ Check for blind option or brltty
823 config_blind(){
824 BLIND=""
825 checkbootparam "blind" && BLIND="yes"
826 BRLTTY="$(getbootparam brltty 2>>$DEBUG)"
827
828 if [ -n "$BLIND" -o -n "$BRLTTY" ]; then
829   if [ -x /sbin/brltty ]; then
830     # Blind option detected, start brltty now.
831     # modprobe serial_core parport_serial generic_serial && echo "done"
832     CMD=brltty
833     BRLTYPE=""
834     BRLDEV=""
835     BRLTEXT=""
836     if [ -n "$BRLTTY" ]; then
837       # Extra options
838       BRLTYPE="${BRLTTY%%,*}"
839       R="${BRLTTY#*,}"
840       if [ -n "$R" -a "$R" != "$BRLTTY" ]; then
841         BRLTTY="$R"
842         BRLDEV="${BRLTTY%%,*}"
843         R="${BRLTTY#*,}"
844         if [ -n "$R" -a "$R" != "$BRLTTY" ]; then
845           BRLTTY="$R"
846           BRLTEXT="${BRLTTY%%,*}"
847           R="${BRLTTY#*,}"
848         fi
849       fi
850     fi
851     [ -n "$BRLTYPE" ] && CMD="$CMD -b $BRLTYPE"
852     [ -n "$BRLDEV"  ] && CMD="$CMD -d $BRLDEV"
853     [ -n "$BRLTEXT" ] && CMD="$CMD -t $BRLTEXT"
854     einfo "Starting braille-display manager."
855 #    ( exec $CMD & )
856     ( sh -c "$CMD" & )
857     sleep 2 && BLINDSOUND="yes"
858     eend 0
859   fi
860 fi
861 }
862 # }}}
863
864 # {{{ Interactive configuration
865 config_interactive(){
866 if [ -n "$INTERACTIVE" ] ; then
867 einfo "Entering interactive configuration second stage."
868
869   echo " ${GREEN}Your console keyboard defaults to: ${MAGENTA}${KEYTABLE}"
870   echo -n "${CYAN}Do you want to (re)configure your console keyboard?${NORMAL} [Y/n] "
871   read a
872   [ "$a" != "n" ] && /usr/sbin/dpkg-reconfigure console-data ; eend $?
873
874   echo -n "${CYAN}Do you want to (re)configure your soundcard?${NORMAL} [Y/n] "
875   read a
876   [ "$a" != "n" ] && alsaconf && ( exec aumix -m 0 >>$DEBUG 2>&1 & ) ; eend $?
877
878   echo -n "${CYAN}Do you want to (re)configure your graphics (X11) subsystem?${NORMAL} [Y/n] "
879   read a
880   [ "$a" != "n" ] && xorgcfg -textmode ; eend $?
881   echo " ${GREEN}Interactive configuration finished. Everything else should be fine for now.${NORMAL}"
882 fi
883 eend 0
884 }
885 # }}}
886
887 # {{{ AGP
888 config_agp(){
889 if checkbootparam forceagp ; then
890 # Probe for AGP. Hope this can fail safely
891   stringinfile "AGP" "/proc/pci" 2>>$DEBUG && { modprobe agpgart || modprobe agpgart agp_try_unsupported=1; } >>$DEBUG 2>&1 && einfo "AGP bridge detected." ; eend 0
892 fi
893 }
894 # }}}
895
896 # {{{ automount(er)
897 config_automounter(){
898 if checkbootparam automounter ; then
899   RUNLEVEL="$(runlevel)"
900   AUTOMOUNTER=""
901   [ -x /etc/init.d/autofs ] && [ "$RUNLEVEL" != "N 1" ] && [ "$RUNLEVEL" != "N S" ] && AUTOMOUNTER="yes"
902
903 addautomount(){
904 # /dev/ice  options
905   d="${1##*/}"
906   if [ -n "$AUTOMOUNTER" ]; then
907     [ -d "/mnt/$d" -a ! -L "/mnt/$d" ] && rmdir /mnt/$d
908     [ -d "/mnt/auto/$d" ] || mkdir -p "/mnt/auto/$d"
909     [ -L "/mnt/$d" ]      || ln -s "/mnt/auto/$d" "/mnt/$d"
910     anew="$d        -fstype=auto,$2 :$i"
911     stringinfile "$anew" "/etc/auto.mnt" || echo "$anew" >> /etc/auto.mnt
912     AUTOMOUNTS="$AUTOMOUNTS $d"
913     new="$1 /mnt/auto/$d  auto   users,noauto,exec,$2 0 0"
914   else
915     [ -d /mnt/$d ] && mkdir -p /mnt/$d
916     new="$1 /mnt/$d  auto   users,noauto,exec,$2 0 0"
917   fi
918   stringinfile "$new" "/etc/fstab" || echo "$new" >> /etc/fstab
919 }
920
921   AUTOMOUNTS="floppy cdrom"
922 # Add new devices to /etc/fstab and /etc/auto.mnt
923   for i in /dev/cdrom?*; do
924     if [ -L $i ]; then
925       addautomount "$i" "ro"
926     fi
927   done
928 fi
929
930 if [ -n "$AUTOMOUNTER" ]; then
931 # Check for floppy dir, reinstall with automounter
932   [ -d /mnt/floppy -a ! -L /mnt/floppy ] && rmdir /mnt/floppy
933   [ -d /mnt/auto/floppy ] || mkdir -p /mnt/auto/floppy
934   [ -L /mnt/floppy ] || ln -s /mnt/auto/floppy /mnt/floppy
935   [ -d /mnt/cdrom -a ! -L /mnt/cdrom ] && rmdir /mnt/cdrom
936   [ -d /mnt/auto/cdrom ] || mkdir -p /mnt/auto/cdrom
937   [ -L /mnt/cdrom ] || ln -s /mnt/auto/cdrom /mnt/cdrom
938   rm -f /etc/fstab.new
939 # Replace paths from bootfloppy
940   sed 's|/mnt/cdrom|/mnt/auto/cdrom|g;s|/mnt/floppy|/mnt/auto/floppy|g' /etc/fstab > /etc/fstab.new
941   mv -f /etc/fstab.new /etc/fstab
942 # Start automounter now
943   einfo "Starting automounter for ${AUTOMOUNTS}."
944   /etc/init.d/autofs start >>$DEBUG ; eend $?
945 fi
946 }
947 # }}}
948
949 # {{{ Collect partitions from /proc/partitions first for enabling DMA
950 check_partitions(){
951 partitions=""
952 IDEDISKS=""
953 while read major minor blocks partition relax; do
954   partition="${partition##*/}"
955   [ -z "$partition" -o ! -e "/dev/$partition" ] && continue
956   case "$partition" in
957     hd?) IDEDISKS="$IDEDISKS $partition";;                # IDE  Harddisk, entire disk
958     sd?) ;;                                               # SCSI Harddisk, entire disk
959 #    [hs]d*) partitions="$partitions /dev/$partition";;    # IDE or SCSI disk partition
960     [hs]d*|ub*) partitions="$partitions /dev/$partition";;    # IDE, USB or SCSI disk partition
961   esac
962 done <<EOT
963 $(awk 'BEGIN{old="__start"}{if($0==old){exit}else{old=$0;if($4&&$4!="name"){print $0}}}' /proc/partitions)
964 EOT
965 }
966 check_partitions 1>/dev/null 2>&1 # avoid output "check_partitions:3: read-only file system"
967 # }}}
968
969 # {{{ Enable DMA for all IDE drives now if not disabled
970 # Notice: Already done by linuxrc, but make sure it's done also on harddisk-installed systems
971 config_dma(){
972 if checkbootparam "nodma"; then
973   ewarn "Skipping DMA accelleration as requested on boot commandline." ; eend 0
974 else
975   for d in $(cd /proc/ide 2>>$DEBUG && echo hd[a-z]); do
976     if test -d /proc/ide/$d; then
977       if egrep -q 'using_dma[ \t]+0' /proc/ide/$d/settings 2>>$DEBUG; then
978         MODEL="$(cat /proc/ide/$d/model 2>>$DEBUG)"
979         test -z "$MODEL" && MODEL="[GENERIC IDE DEVICE]"
980         einfo "Enabling DMA acceleration for: ${WHITE}$d        ${YELLOW}[${MODEL}]${NORMAL}"
981         echo "using_dma:1" >/proc/ide/$d/settings
982         eend 0
983       fi
984     fi
985   done
986 fi
987 }
988 # }}}
989
990 # {{{ Start creating /etc/fstab with HD partitions and USB SCSI devices now
991 config_fstab(){
992
993 NOSWAP="yes" # we do not use swap by default!
994 if checkbootparam "swap" -o checkbootparam "anyswap" ; then
995    NOSWAP=''
996 fi
997
998 if checkbootparam "nofstab" -o checkbootparam "forensic" ; then
999   ewarn "Skipping /etc/fstab creation as requested on boot commandline." ; eend 0
1000 else
1001   checkbootparam "anyswap" && export ANYSWAP='yes' || export ANYSWAP=""
1002   einfo "Scanning for harddisk partitions and creating /etc/fstab. (Disable this via boot option: nofstab)"
1003   iszsh && setopt nonomatch
1004   if [ -x /usr/sbin/rebuildfstab ] ; then
1005     config_userfstab || fstabuser=grml
1006     /usr/sbin/rebuildfstab -r -u $fstabuser -g $fstabuser ; eend $?
1007   else
1008     ewarn "Command rebuildfstab not found. Install package grml-rebuildfstab." ; eend 1
1009   fi
1010   if [ -e /var/run/rebuildfstab.pid ]; then
1011     # Another instance of rebuildfstab, probably from hotplug, is still running, so just wait.
1012     sleep 8
1013   fi
1014 fi
1015 # Scan for swap, config, homedir
1016 if [ -z "$NOSWAP" ]; then
1017    einfo "Searching for swap partition(s) as requested."
1018 fi
1019 GRML_IMG=""
1020 GRML_SWP=""
1021 HOMEDIR="$(getbootparam home)"
1022 if [ -n "$partitions" ]; then
1023  while read p m f relax; do
1024   case "$p" in *fd0*|*proc*|*sys*|*\#*) continue;; esac
1025   partoptions="users,exec"
1026   fnew=""
1027   case "$f" in swap)
1028    eindent
1029    if [ -n "$NOSWAP" ]; then
1030       if [ -z "$INSTALLED" ] ; then
1031          ewarn "Ignoring swap partition ${WHITE}$p${NORMAL}. (Force usage via boot option 'swap', or execute grml-swapon)" ; eend 0
1032       fi
1033    else
1034      case "$(dd if=$p bs=1 count=6 skip=4086 2>/dev/null)" in
1035              S1SUSP|S2SUSP|pmdisk|[zZ]*)
1036                 if [ -n "$ANYSWAP" ] ; then
1037                   einfo "Using swap partition ${WHITE}${p}${NORMAL} [bootoption anyswap found]."
1038                   swapon $p 2>>$DEBUG ; eend $?
1039                 else
1040                   ewarn "Suspend signature on ${WHITE}${p}${NORMAL} found, not using as swap. (Force usage via boot option: anyswap)"
1041                 fi
1042                ;;
1043              *)
1044                 if [[ "$p" == LABEL* ]] ; then
1045                    p=$(blkid -t $p | awk -F: '{print $1}')
1046                 fi
1047                 if grep -q $p /proc/swaps ; then
1048                    ewarn "Not using swap partition ${WHITE}${p}${NORMAL} as it is already in use." ; eend 0
1049                 else
1050                    einfo "Using swap partition ${WHITE}${p}${NORMAL}."
1051                    swapon $p 2>>$DEBUG ; eend $?
1052                 fi
1053                ;;
1054      esac
1055    fi
1056    eoutdent
1057    continue
1058    ;;
1059   esac
1060 # Create mountdir if not already present, but don't try to create stuff like /proc/bus/usb
1061 # Notice: grml-rebuildfstab >= 0.3-1 handles this now
1062 #  case "$m" in *none*|*proc*|*sys*|'') continue ;; esac
1063 #  [ -d "$m" ] || mkdir -p "$m"
1064 # WARNING: NTFS RW mounts are only safe since Kernel 2.6.11
1065   [ "$f" = "ntfs" -a "${KERNEL%.*}" != "2.6" ] && continue
1066   MOUNTOPTS="ro"
1067   case "$f" in
1068     vfat|msdos|ntfs) MOUNTOPTS="$MOUNTOPTS,uid=${fstabuser},gid=${fstabuser}" ;;
1069     ext2|ext3|reiserfs|jfs|reiser4|xfs) MOUNTOPTS="$MOUNTOPTS,noatime" ;;
1070     *) continue ;;
1071     # *) NONEFOUND='1'; continue ;;
1072   esac
1073   if [ -z "$NOSWAP" ] ; then
1074      mount -o "$MOUNTOPTS" -t $f $p $m 2>>$DEBUG || continue
1075      # Activate swapfile, if exists
1076      SWAPFILE="$(/bin/ls -1d $m/[Gg][Rr][Mm][Ll].[Ss][Ww][Pp] 2>/dev/null)"
1077   fi
1078   if [ -z "$NOSWAP" -a -n "$SWAPFILE" -a -f "$SWAPFILE" ]; then
1079    mount -o remount,rw $m
1080    if swapon "$SWAPFILE" 2>>$DEBUG ; then
1081     einfo "Using GRML swapfile ${SWAPFILE}."
1082     fnew="$SWAPFILE swap swap defaults 0 0"
1083     stringinfile "$fnew" "/etc/fstab" || echo "$fnew" >> /etc/fstab
1084     GRML_SWP="$GRML_SWP $SWAPFILE"
1085     eend 0
1086    fi
1087    mount -o remount,ro $m 2>>$DEBUG
1088   fi
1089   IMAGE="$(/bin/ls -1d $m/[Gg][Rr][Mm][Ll].[Ii][Mm][Gg] 2>/dev/null)"
1090   if [ -z "$INSTALLED" -a -z "$GRML_IMG" -a -n "$IMAGE" -a -f "$IMAGE" ]; then
1091    if [ -n "$HOMEDIR" ]; then
1092     if [ "$HOMEDIR" != "scan" -a "$HOMEDIR" != "$IMAGE" -a "$HOMEDIR" != "${IMAGE%/*.*}" ]; then
1093      continue
1094     fi
1095    fi
1096    if type -a grml-image >/dev/null 2>&1 && grml-image "$IMAGE" </dev/console >/dev/console 2>&1; then
1097     GRML_IMG="$IMAGE"
1098     mount -o remount,ro $m 2>>$DEBUG
1099    fi
1100   fi
1101   eend 0
1102   # Umount, if not in use
1103   umount -r $m 2>/dev/null
1104  done <<EOT
1105 $(cat /etc/fstab)
1106 EOT
1107 fi
1108 }
1109 # }}}
1110
1111 # {{{ Mouse
1112 config_mouse(){
1113 if [ -n "$MOUSE_DEVICE" ] ; then
1114   einfo "Detecting mouse: ${MOUSE_FULLNAME} at ${MOUSE_DEVICE}" ; eend $?
1115 fi
1116 }
1117 # }}}
1118
1119 # {{{ IPv6 configuration
1120 # Load IPv6 kernel module and print IP adresses
1121 config_ipv6(){
1122 if checkbootparam "ipv6"; then
1123   einfo "Enabling IPv6 as requested on boot commandline (sleeping for 2 seconds)"
1124   modprobe ipv6
1125   # we probably need some time until stateless autoconfiguration has happened
1126   sleep 2
1127   NETDEVICES="$(awk -F: '/eth.:|tr.:|wlan.:/{print $1}' /proc/net/dev 2>>$DEBUG)"
1128   for DEVICE in `echo "$NETDEVICES"`; do
1129     eindent
1130       einfo "$DEVICE:"
1131       ADDRESSES="$(ifconfig $DEVICE | awk '/.*inet6 addr:.*/{print $3}')"
1132       COUNT="$(ifconfig $DEVICE | awk '/.*inet6 addr:.*/{ sum += 1};END {print sum }')"
1133       eindent
1134         for ADDR in `echo "$ADDRESSES"` ; do
1135             einfo "$ADDR"
1136         done
1137         if [ "$COUNT" -eq "0" ] ; then
1138            einfo "(none)" ; eend 1
1139         fi
1140       eoutdent
1141     eoutdent
1142   done
1143   eend 0
1144 fi
1145 }
1146 # }}}
1147
1148 # {{{ Fat-Client-Version: DHCP Broadcast for IP address
1149 config_dhcp(){
1150 if checkbootparam "nodhcp"; then
1151   ewarn "Skipping DHCP broadcast/network detection as requested on boot commandline." ; eend 0
1152 else
1153   NETDEVICES="$(awk -F: '/eth.:|tr.:|wlan.:/{print $1}' /proc/net/dev 2>>$DEBUG)"
1154   rm -rf /etc/network/status ; mkdir -p /etc/network/status
1155   for DEVICE in `echo "$NETDEVICES"` ; do
1156     einfo "Network device ${WHITE}${DEVICE}${NORMAL} detected, DHCP broadcasting for IP. (Backgrounding)"
1157     trap 2 3 11
1158     ifconfig $DEVICE up >>$DEBUG 2>&1
1159     ( pump -i $DEVICE >>$DEBUG 2>&1 && echo finished_running_pump > /etc/network/status/$DEVICE ) &
1160     trap "" 2 3 11
1161     sleep 1
1162     eend 0
1163   done
1164 fi
1165 }
1166 # }}}
1167
1168 # {{{ helper functions
1169 findfile(){
1170 FOUND=""
1171 # search all partitions for a file in the root directory
1172 for i in /mnt/[sh]d[a-z] /mnt/[sh]d[a-z][1-9] /mnt/[sh]d[a-z][1-9]?*; do
1173 # See if it's already mounted
1174   [ -f "$i/$1" ] &&  { echo "$i/$1"; return 0; }
1175   if [ -d "$i" ] && mount -r "$i" 2>>$DEBUG; then
1176     [ -f "$i/$1" ] && FOUND="$i/$1"
1177     umount -l "$i" 2>>$DEBUG
1178     [ -n "$FOUND" ] && { echo "$FOUND"; return 0; }
1179   fi
1180 done
1181 return 2
1182 }
1183
1184 fstype(){
1185 case "$(file -s $1)" in
1186   *[Ff][Aa][Tt]*|*[Xx]86*) echo "vfat"; return 0;;
1187   *[Rr][Ee][Ii][Ss][Ee][Rr]*)  echo "reiserfs"; return 0;;
1188   *[Xx][Ff][Ss]*)  echo "xfs"; return 0;;
1189   *[Ee][Xx][Tt]3*) echo "ext3"; return 0;;
1190   *[Ee][Xx][Tt]2*) echo "ext2"; return 0;;
1191   *data*)          echo "invalid"; return 0;;
1192   *) echo "auto"; return 0;;
1193 esac
1194 }
1195
1196 # Try to mount this filesystem read-only, without or with encryption
1197 trymount(){
1198 # Check if already mounted
1199 case "$(cat /proc/mounts)" in *\ $2\ *) return 0;; esac
1200 # Apparently, mount-aes DOES autodetect AES loopback files.
1201 [ -b "$1" ] && { mount -t auto -o ro "$1" "$2" 2>>$DEBUG; RC="$?"; }
1202 # We need to mount crypto-loop files with initial rw support
1203 [ -f "$1" ] && { mount -t auto -o loop,rw "$1" "$2" 2>>$DEBUG; RC="$?"; }
1204 # Mount succeeded?
1205 [ "$RC" = "0" ] && return 0
1206 echo ""
1207 einfo "Filesystem not autodetected, trying to mount $1 with AES256 encryption."
1208 a="y"
1209 while [ "$a" != "n" -a "$a" != "N" ]; do
1210 # We need to mount crypto-loop files with initial rw support
1211  mount -t auto -o loop,rw,encryption=AES256 "$1" "$2" && return 0
1212  echo -n "${RED}Mount failed, retry? [Y/n] ${NORMAL}"
1213  # Problem with ioctl() from getpasswd()?
1214  # read a
1215  read a
1216 done
1217 return 1
1218 }
1219 # }}}
1220
1221 # {{{ CPU-detection
1222 config_cpu(){
1223 if checkbootparam "nocpu"; then
1224   ewarn "Skipping CPU detection as requested on boot commandline." ; eend 0
1225 else
1226   # check module dependencies
1227   cpufreq_check() {
1228    if [ -e /lib64 ] ; then
1229       [ -e /lib/modules/${KERNEL}/kernel/arch/x86_64/kernel/cpufreq ] || return 1
1230    else
1231       [ -e /lib/modules/${KERNEL}/kernel/arch/i386/kernel/cpu/cpufreq -o ! -e /lib/modules/${KERNEL}/kernel/drivers/cpufreq ] || return 1
1232    fi
1233   }
1234
1235   if [[ `grep -c processor /proc/cpuinfo` -gt 1 ]] ; then
1236      einfo "Detecting CPU:"
1237      CPU=$(awk -F: '/^processor/{printf "       Processor"$2" is"};/^model name/{printf $2};/^vendor_id/{printf vendor};/^cpu MHz/{printf " %dMHz",int($2)};/^cache size/{printf ","$2" Cache"};/^$/{print ""}' /proc/cpuinfo 2>>$DEBUG)
1238      echo $CPU | sed 's/ \{1,\}/ /g'
1239      eend 0
1240   else
1241      einfo "Detecting CPU: `awk -F: '/^processor/{printf " Processor"$2" is"};/^model name/{printf $2};/^vendor_id/{printf vendor};/^cpu MHz/{printf " %dMHz",int($2)};/^cache size/{printf ","$2" Cache"};/^$/{print ""}' /proc/cpuinfo 2>>$DEBUG` " ; eend 0
1242   fi
1243
1244   if ! cpufreq_check ; then
1245     ewarn "Skipping cpufreq setup as module dependencies are not fulfilled." ; eend 1
1246   else
1247     if /usr/sbin/laptop-detect ; then
1248        einfo "Detected Laptop - trying to use cpu frequency scaling:"
1249        if [ -r /usr/bin/cpufreq-detect.sh ] ; then
1250           eindent
1251           . /usr/bin/cpufreq-detect.sh
1252           if [ -n "$MODULE" -a "$MODULE" != none ]; then
1253              einfo "Loading modules ${MODULE} and cpufreq_ondemand, setting ondemand governor"
1254              modprobe "$MODULE" 1>>$DEBUG || modprobe "$MODULE_FALLBACK" 1>>$DEBUG
1255              if modprobe cpufreq_ondemand && RC=0 || RC=1 ; then
1256                 for file in $(find /sys/devices/system/cpu/ -name scaling_governor 2>/dev/null) ; do
1257                     echo ondemand > $file
1258                 done
1259              fi
1260              eend $RC
1261           else
1262              ewarn "Could not detect an appropriate CPU for use with cpu frequency scaling - skipping." && eend 1
1263           fi
1264           eoutdent
1265        fi # cpufreq-detect
1266     fi # laptop-detect
1267   fi # cpufreq_check
1268 fi # checkbootparam nocpu
1269 }
1270 # }}}
1271
1272 # {{{ autostart of ssh
1273 config_ssh(){
1274 if checkbootparam ssh ; then
1275   SSH_PASSWD="$(getbootparam 'ssh' 2>>$DEBUG)"
1276   einfo "Bootoption passwd found."
1277   if [ -n "$SSH_PASSWD" ] ; then
1278     echo "grml:$SSH_PASSWD" | chpasswd -m
1279     einfo "Starting secure shell server in background."
1280     /etc/init.d/rmnologin start 1>>$DEBUG 2>>$DEBUG
1281     /etc/init.d/ssh start 1>>$DEBUG 2>>$DEBUG &
1282     eend 0
1283   else
1284     eerror "No given password for ssh found. Autostart of SSH will not work." ; eend 1
1285   fi
1286   eindent
1287     ewarn "Warning: please change the password for user grml set via bootparameter as soon as possible!"
1288   eoutdent
1289 fi
1290 }
1291 # }}}
1292
1293 # {{{ set password for user grml
1294 config_passwd(){
1295 if checkbootparam passwd >>$DEBUG 2>&1; then
1296   einfo "Bootoption passwd found."
1297   PASSWD="$(getbootparam 'passwd' 2>>$DEBUG)"
1298   if [ -n "$PASSWD" ] ; then
1299     echo "grml:$PASSWD" | chpasswd -m ; eend $?
1300   else
1301     eerror "No given password for ssh found. Autostart of SSH will not work." ; eend 1
1302   fi
1303   eindent
1304     ewarn "Warning: please change the password for user grml set via bootparameter as soon as possible!"
1305   eoutdent
1306 fi
1307 }
1308 # }}}
1309
1310 # {{{ Check for persistent homedir option and eventually mount /home from there, or use a loopback file.
1311 config_homedir(){
1312 if checkbootparam home ; then
1313 HOMEDIR="$(getbootparam home)"
1314 MYHOMEDEVICE=""
1315 MYHOMEMOUNTPOINT=""
1316 MYHOMEDIR=""
1317 if [ -n "$HOMEDIR" ]; then
1318   einfo "Bootoption home detected." && eend 0
1319   case "$HOMEDIR" in
1320     /dev/*)
1321     MYHOMEDEVICE="${HOMEDIR##/dev/}"
1322     MYHOMEDEVICE="/dev/${MYHOMEDEVICE%%/*}"
1323     MYHOMEMOUNTPOINT="/mnt/${MYHOMEDEVICE##/dev/}"
1324     MYHOMEDIR="/mnt/${HOMEDIR##/dev/}"
1325   ;;
1326     /mnt/*)
1327     MYHOMEDEVICE="${HOMEDIR##/mnt/}"
1328     MYHOMEDEVICE="/dev/${MYHOMEDEVICE%%/*}"
1329     MYHOMEMOUNTPOINT="/mnt/${MYHOMEDEVICE##/dev/}"
1330     MYHOMEDIR="$HOMEDIR"
1331   ;;
1332     [Aa][Uu][Tt][Oo]|[Ss][Cc][Aa][Nn]|[Ff][Ii][Nn][Dd])
1333     MYHOMEDIR="$(findfile grml.img)"
1334     MYHOMEDEVICE="${MYHOMEDIR##/mnt/}"
1335     MYHOMEDEVICE="/dev/${MYHOMEDEVICE%%/*}"
1336     MYHOMEMOUNTPOINT="/mnt/${MYHOMEDEVICE##/dev/}"
1337   ;;
1338   *)
1339     eerror "Invalid home= option '$HOMEDIR' specified (must start with /dev/ or /mnt/ or 'scan')." ; eend 1
1340     eerror "Option ignored." ; eend 1
1341   ;;
1342   esac
1343 fi
1344
1345 if [ -n "$MYHOMEDIR" ]; then
1346   if trymount "$MYHOMEDEVICE" "$MYHOMEMOUNTPOINT"; then
1347     [ -f "$MYHOMEMOUNTPOINT/grml.img" ] && MYHOMEDIR="$MYHOMEMOUNTPOINT/grml.img"
1348     while read device mountpoint fs relax; do
1349       case "$mountpoint" in *$MYHOMEMOUNTPOINT*)
1350         case "$fs" in *[Nn][Tt][Ff][Ss]*)
1351           umount "$MYHOMEMOUNTPOINT"; eerror "Error: will not mount NTFS filesystem on $MYHOMEDEVICE read/write!" ; eend 1
1352           break
1353         ;;
1354         *[Ff][Aa][Tt]*)
1355         # Note: This currently won't work with encrypted partitions
1356         umount "$MYHOMEMOUNTPOINT"; mount -t vfat -o rw,uid=grml,gid=grml,umask=002 "$MYHOMEDEVICE" "$MYHOMEMOUNTPOINT"
1357         if [ ! -f "$MYHOMEDIR" ]; then
1358           ewarn "WARNING: FAT32 is not a good filesystem option for /home/grml (missing socket/symlink support)."
1359           ewarn "WARNING: Better use an ext2 loopback file on this device, and boot with home=$MYHOMEDEVICE/grml.img."
1360         fi
1361         ;;
1362       esac
1363       if mount -o remount,rw "$MYHOMEMOUNTPOINT"; then
1364         einfo "Mounting ${WHITE}$MYHOMEDIR${NORMAL} as ${WHITE}/home/grml${NORMAL}."
1365         if [ -f "$MYHOMEDIR" ]; then
1366           # It's a loopback file, mount it over the /home/grml directory
1367           trymount "$MYHOMEDIR" /home/grml
1368           RC="$?"
1369           [ "$RC" = "0" ] && ERROR="$(mount -o remount,rw /home/grml 2>&1)"
1370           RC="$?"
1371         else
1372           # Do a --bind mount
1373           ERROR="$(mount --bind "$MYHOMEDIR" /home/grml 2>&1)"
1374           RC="$?"
1375         fi
1376         [ "$RC" = "0" ] && eend 0 || ( eerror "${ERROR}" ; eend 1 )
1377       fi
1378       break
1379       ;;
1380     esac
1381   done <<EOT
1382 $(cat /proc/mounts)
1383 EOT
1384   fi
1385 fi
1386 fi # checkbootparam home
1387 }
1388 # }}}
1389
1390 # {{{ Check for scripts on CD-ROM
1391 config_cdrom_scripts(){
1392 if checkbootparam "script"; then
1393   for script in /cdrom/scripts/* ; do
1394     einfo " grml script found on CD, executing ${WHITE}${script}${NORMAL}."
1395     . $script
1396   done
1397 fi
1398 }
1399 # }}}
1400
1401 # {{{ Sound
1402 config_mixer(){
1403 if ! [ -x /usr/bin/aumix ] ; then
1404   eerror "aumix binary not available. Can not set sound volumes therefore." ; eend 1
1405 else
1406
1407   if checkbootparam vol ; then
1408     VOL="$(getbootparam 'vol' 2>>$DEBUG)"
1409     if [ -z "$VOL" ] ; then
1410       eerror "Bootoption vol found but no volume level/parameter given. Using defaults." ; eend 1
1411       VOL='75' # default
1412     fi
1413   else
1414     VOL='75' # default
1415   fi
1416
1417   if checkbootparam nosound ; then
1418     einfo "Muting sound devices on request."
1419     # some IBM notebooks require the following stuff:
1420     if [ -x /usr/bin/amixer ] ; then
1421        if amixer get Front 1>/dev/null 2>>$DEBUG ; then
1422           amixer set Front unmute 1>/dev/null
1423           amixer set Front 0% 1>/dev/null
1424        fi
1425     fi
1426     ERROR=$(aumix -w 0 -v 0 -p 0 -m 0 2>&1) ; RC=$?
1427     if [ -n "$ERROR" ] ; then
1428        eindent
1429        eerror "Problem muting sound devices: $ERROR"
1430        eoutdent
1431     fi
1432     eend $RC
1433   elif [ -z "$INSTALLED" ]; then
1434       einfo "Setting mixer volumes to level ${WHITE}${VOL}${NORMAL}."
1435       # some IBM notebooks require the following stuff:
1436       if [ -x /usr/bin/amixer ] ; then
1437          if amixer get Front 1>/dev/null 2>>$DEBUG ; then
1438             amixer set Front unmute 1>/dev/null
1439             amixer set Front ${VOL}% 1>/dev/null
1440          fi
1441       fi
1442       ERROR=$(aumix -w $VOL -v $VOL -p $VOL -m $VOL 2>&1) ; RC=$?
1443       if [ -n "$ERROR" ] ; then
1444          eindent
1445          eerror "Problem setting mixer volumes: $ERROR"
1446          eoutdent
1447       fi
1448       eend $RC
1449   fi
1450
1451 fi
1452 }
1453 # }}}
1454
1455 # {{{ modem detection
1456 config_modem(){
1457 if checkbootparam "nomodem"; then
1458   ewarn "Skipping check for AC97 modem controller as requested on boot commandline." ; eend 0
1459 else
1460   if [ -x /etc/init.d/sl-modem-daemon ] ; then
1461    if lspci | grep Intel | grep -q "AC'97 Modem Controller" ; then
1462      einfo "AC97 modem controller detected. Starting sl-modem-daemon in background."
1463      /etc/init.d/sl-modem-daemon start >>$DEBUG &
1464      eend 0
1465    fi
1466   fi
1467 fi
1468 }
1469 # }}}
1470
1471 # {{{ keyboard add-ons
1472 config_setkeycodes(){
1473 if checkbootparam "setkeycodes" ; then
1474  einfo "Setting keycodes as requested via bootparameter 'setkeycodes'."
1475   # MS MM keyboard add-on
1476   # fix
1477   setkeycodes e001 126 &>/dev/null
1478   setkeycodes e059 127 &>/dev/null
1479   # fn keys
1480   setkeycodes e03b 59 &>/dev/null
1481   setkeycodes e008 60 &>/dev/null
1482   setkeycodes e007 61 &>/dev/null
1483   setkeycodes e03e 62 &>/dev/null
1484   setkeycodes e03f 63 &>/dev/null
1485   setkeycodes e040 64 &>/dev/null
1486   setkeycodes e041 65 &>/dev/null
1487   setkeycodes e042 66 &>/dev/null
1488   setkeycodes e043 67 &>/dev/null
1489   setkeycodes e023 68 &>/dev/null
1490   setkeycodes e057 87 &>/dev/null
1491   setkeycodes e058 88 &>/dev/null
1492   # hp keycodes
1493   setkeycodes e00a 89 e008 90 &>/dev/null
1494  eend 0
1495 fi
1496 }
1497 # }}}
1498
1499 # {{{ wondershaper
1500 config_wondershaper(){
1501  if checkbootparam "wondershaper" ; then
1502     WONDER="$(getbootparam wondershaper 2>>$DEBUG)"
1503     CMD=wondershaper
1504     DEVICE=""
1505     DOWNSTREAM=""
1506     UPSTREAM=""
1507     if [ -n "$WONDER" ]; then
1508       # Extra options
1509       DEVICE="${WONDER%%,*}"
1510       R="${WONDER#*,}"
1511       if [ -n "$R" -a "$R" != "$WONDER" ]; then
1512         WONDER="$R"
1513         DOWNSTREAM="${WONDER%%,*}"
1514         R="${WONDER#*,}"
1515         if [ -n "$R" -a "$R" != "$WONDER" ]; then
1516           WONDER="$R"
1517           UPSTREAM="${WONDER%%,*}"
1518           R="${WONDER#*,}"
1519         fi
1520       fi
1521     fi
1522     [ -n "$DEVICE" ]     && CMD="$CMD $DEVICE"
1523     [ -n "$DOWNSTREAM" ] && CMD="$CMD $DOWNSTREAM"
1524     [ -n "$UPSTREAM" ]   && CMD="$CMD $UPSTREAM"
1525     einfo "Starting wondershaper (${CMD}) in background."
1526     ( sh -c $CMD & ) && eend 0
1527  fi
1528 }
1529 # }}}
1530
1531 # {{{ syslog-ng
1532 config_syslog(){
1533  if checkbootparam "nosyslog"; then
1534   ewarn "Not starting syslog-ng as requested on boot commandline." ; eend 0
1535  else
1536   einfo "Starting syslog-ng in background."
1537   /etc/init.d/syslog-ng start 1>>$DEBUG &
1538   eend 0
1539  fi
1540 }
1541 # }}}
1542
1543 # {{{ gpm
1544 config_gpm(){
1545  if checkbootparam "nogpm"; then
1546   ewarn "Not starting GPM as requested on boot commandline." ; eend 0
1547  else
1548   einfo "Starting gpm in background."
1549 #  /etc/init.d/gpm start 1>>$DEBUG &
1550   ( while [ ! -e /dev/psaux ]; do sleep 5; done; /etc/init.d/gpm start 1>>$DEBUG ) &
1551   eend 0
1552  fi
1553 }
1554 # }}}
1555
1556 # {{{ services
1557 config_services(){
1558  if checkbootparam "services" ; then
1559     SERVICE="$(getbootparam services 2>>$DEBUG)"
1560     SERVICELIST=$(echo "$SERVICE" | sed 's/,/\\n/g')
1561     SERVICENL=$(echo "$SERVICE" | sed 's/,/ /g')
1562     einfo "Starting service(s) ${SERVICENL} in background."
1563     for service in $(echo -e $SERVICELIST) ; do
1564        /etc/init.d/${service} start 1>>$DEBUG &
1565     done
1566     [ "$?" == "0" ] ; eend $?
1567  fi
1568 }
1569 # }}}
1570
1571 # {{{ config files
1572 config_netconfig(){
1573  if checkbootparam netconfig ; then
1574   CONFIG="$(getbootparam 'netconfig' 2>>$DEBUG)"
1575   CONFIGFILE='/tmp/netconfig.grml'
1576
1577   getconfig() {
1578   wget --timeout=10 --dns-timeout=10  --connect-timeout=10 \
1579        --read-timeout=10 $CONFIG -O $CONFIGFILE && return 0 || return 1
1580   }
1581   einfo "Trying to get ${WHITE}${CONFIG}${NORMAL}"
1582   counter=10
1583   while ! getconfig && [[ "$counter" != 0 ]] ; do
1584     echo -n "Sleeping for 5 seconds and trying to get config again... "
1585     counter=$(( counter-1 ))
1586     echo "$counter tries left" ; sleep 1
1587   done
1588   if [ -r "$CONFIGFILE" ] ; then
1589     einfo "Downloading was successfull." ; eend 0
1590     einfo "md5sum of ${WHITE}${CONFIG}${NORMAL}: "
1591     md5sum $CONFIGFILE ; eend 0
1592     cd / && einfo "Unpacking ${WHITE}${CONFIGFILE}${NORMAL}:" && /usr/bin/unp $CONFIGFILE $EXTRACTOPTIONS ; eend $?
1593   else
1594     einfo "Sorry, could not fetch $CONFIG" ; eend 1
1595   fi
1596  fi
1597 }
1598 # }}}
1599
1600 # {{{ blindsound
1601 config_blindsound(){
1602  if checkbootparam "blind" ; then
1603     beep
1604     flite -o play -t "welcome to the gremel system"
1605  fi
1606 }
1607 # }}}
1608
1609 # {{{ welcome sound
1610 config_welcome(){
1611  if checkbootparam welcome ; then
1612   flite -o play -t "welcome to the gremel system"
1613  fi
1614 }
1615 # }}}
1616
1617 # {{{ fix/workaround for unionfs
1618 fix_unionfs(){
1619   if [ -z "$INSTALLED" ]; then
1620    touch /var/cache/apt/*cache.bin
1621   fi
1622 }
1623 # }}}
1624
1625 # {{{ create all /mnt-directories
1626 create_mnt_dirs(){
1627   ewarn "create_mnt_dirs is deprecated as grml-rebuildfstab does all we need."
1628   ewarn "Please set CONFIG_CREATE_MNT_DIRS='no' in /etc/grml/autoconfig" ; eend 0
1629 }
1630 # }}}
1631
1632 # {{{ start X window system via grml-x
1633 config_x_startup(){
1634 if checkbootparam startx ; then
1635  if [ -x /usr/X11R6/bin/X ] ; then
1636   if [ -z "$INSTALLED" ] ; then
1637    WINDOWMANAGER="$(getbootparam 'startx' 2>>$DEBUG)"
1638    if [ -z "$WINDOWMANAGER" ] ; then
1639      einfo "No window manager specified. Taking ${WHITE}wm-ng${NORMAL} as default." && eend 0
1640      WINDOWMANAGER="wm-ng"
1641    else
1642      einfo "Window manager ${WHITE}${WINDOWMANAGER}${NORMAL} found as bootoption." && eend 0
1643    fi
1644    einfo "Changing to runlevel 5 for starting grml-x ${WINDOWMANAGER}. Just exit X windows system to get full featured consoles."
1645    config_userfstab || fstabuser='grml'
1646  cat>|/etc/init.d/xstartup<<EOF
1647 #!/bin/sh
1648 # su - $fstabuser -c 'grml-x "$WINDOWMANAGER"'
1649 sudo -u $fstabuser -i /usr/bin/grml-x $WINDOWMANAGER 1>>$DEBUG
1650 EOF
1651    chmod 755 /etc/init.d/xstartup
1652
1653    sed -i 's#^6:.*#6:2345:respawn:/bin/zsh --login -c "/etc/init.d/xstartup ; /bin/zsh"#' /etc/inittab
1654
1655    /sbin/telinit q ; eend $?
1656
1657    if grep -q '^allowed_users=' /etc/X11/Xwrapper.config ; then
1658       sed -i 's/^allowed_users=.*/allowed_users=anybody/' /etc/X11/Xwrapper.config
1659    else
1660       echo 'allowed_users=anybody' >> /etc/X11/Xwrapper.config
1661    fi
1662
1663   else
1664     eerror "We are not running from CD - startx will not work, skipping it.
1665      Please use something like xdm, gdm or kdm for starting X on a harddisk system!" ; eend 1
1666   fi
1667  else
1668    eerror "/usr/X11R6/bin/X is not present on this grml flavour.
1669    Boot parameter startx does not work therefore." ; eend 1
1670  fi
1671 fi
1672 }
1673 # }}}
1674
1675 # {{{ configuration framework
1676 config_extract(){
1677 if checkbootparam extract ; then
1678  EXTRACT="$(getbootparam 'extract' 2>>$DEBUG)"
1679  EXTRACTOPTIONS="-- -x $EXTRACT"
1680 fi
1681 }
1682
1683 config_automount(){
1684 if checkbootparam noautoconfig -o checkbootparam forensic ; then
1685   ewarn "Skipping running automount of device(s) labeled GRMLCFG as requested." ; eend 0
1686 else
1687  if [ -z "$INSTALLED" ] ; then
1688   einfo "Searching for device(s) labeled with GRMLCFG." ; eend 0
1689   eindent
1690   [ -d /mnt/grml ] || mkdir /mnt/grml
1691   umount /mnt/grml 1>>$DEBUG 2>&1 # make sure it is not mounted
1692 # We do need the following fix so floppy disk is available to blkid in any case :-/
1693   if [ -r /dev/fd0 ] ; then
1694      einfo "Floppy device detected. Trying to access floppy disk. (Disable this via boot option: noautoconfig)"
1695 #     dd if=/dev/fd0 of=/dev/null bs=512 count=1 1>>$DEBUG 2>&1
1696      if timeout 4 dd if=/dev/fd0 of=/dev/null bs=512 count=1 1>>$DEBUG 2>&1 ; then
1697         blkid /dev/fd0 1>>$DEBUG 2>&1
1698      fi
1699   fi
1700   DEVICE=$(blkid -t LABEL=GRMLCFG | head -1 | awk -F: '{print $1}')
1701   [ -n "$DEVICE" ] && mount -t auto -o ro $DEVICE /mnt/grml ; RC="$?"
1702   if [[ $RC == 0 ]]; then
1703     einfo "Mounting device $DEVICE labeled GRMLCFG succeeded." ; eend 0
1704
1705     CONFIG=''
1706     CONFIG="$(/bin/ls -1d /mnt/grml/[Cc][Oo][Nn][Ff][Ii][Gg].[Tt][Bb][Zz] 2>>$DEBUG)"
1707     if [ -n "$CONFIG" ]; then
1708       einfo "Found file ${WHITE}${CONFIG}${NORMAL} - trying to extract it."
1709       cd /
1710       unp $CONFIG $EXTRACTOPTIONS ; eend $?
1711     else
1712       ewarn "Sorry, could not find file config.tbz on device with label GRMLCFG." ; eend 1
1713     fi
1714
1715     SCRIPT=''
1716     SCRIPT="$(/bin/ls -1d /mnt/grml/[Gg][Rr][Mm][Ll].[Ss][Hh] 2>>$DEBUG)"
1717     if [ -n "$SCRIPT" ]; then
1718       einfo "Found script ${WHITE}${SCRIPT}${NORMAL} - trying to execute it."
1719       $SCRIPT ; eend $?
1720     fi
1721     grep -q '/mnt/grml' /proc/mounts && umount /mnt/grml
1722   else
1723     ewarn "No devices with label GRMLCFG found." ; eend 0
1724   fi
1725   eoutdent
1726  fi
1727 fi
1728 }
1729
1730 config_myconfig(){
1731
1732 if checkbootparam "config" ; then
1733   CONFIG="$(getbootparam 'config' 2>>$DEBUG)"
1734   [ -z "$CONFIG" ] && CONFIG='config.tbz'
1735   einfo "Bootoption config found. config is set to: $CONFIG"
1736   eindent
1737     einfo "Trying to extract configuration file ${CONFIG}:"
1738     cd / && unp /cdrom/config/$CONFIG $EXTRACTOPTIONS ; eend $?
1739   eoutdent
1740 fi
1741
1742 if checkbootparam myconfig ; then
1743  MOUNTDEVICE="$(getbootparam 'myconfig' 2>>$DEBUG)"
1744  if [ -n "$MOUNTDEVICE" ]; then
1745    if checkbootparam file ; then
1746     FILENAME="$(getbootparam 'file' 2>>$DEBUG)"
1747     [ -n "$FILENAME" ] || FILENAME='config.tbz'
1748    fi
1749    [ -d /mnt/grml ] || mkdir /mnt/grml
1750    umount /mnt/grml 1>>$DEBUG 2>&1 # make sure it is not mounted
1751    mount -o ro -t auto $MOUNTDEVICE /mnt/grml ; RC="$?"
1752     if [[ $RC == 0 ]]; then
1753       einfo "Successfully mounted $MOUNTDEVICE to /mnt/grml (readonly)." ; eend 0
1754       eindent
1755       CONFIG=''
1756       CONFIG="$(/bin/ls -1d /mnt/grml/[Cc][Oo][Nn][Ff][Ii][Gg].[Tt][Bb][Zz] 2>>$DEBUG)"
1757       if [ -n "$CONFIG" ]; then
1758         einfo "Found file ${WHITE}${CONFIG}${NORMAL} - trying to extract it."
1759         cd /
1760         unp $CONFIG $EXTRACTOPTIONS ; eend $?
1761       else
1762         ewarn "Sorry, could not find file config.tbz on device with label GRMLCFG." ; eend 1
1763       fi
1764
1765       SCRIPT=''
1766       SCRIPT="$(/bin/ls -1d /mnt/grml/[Gg][Rr][Mm][Ll].[Ss][Hh] 2>>$DEBUG)"
1767       if [ -n "$SCRIPT" ]; then
1768         einfo "Found script ${WHITE}${SCRIPT}${NORMAL} - trying to execute it."
1769         $SCRIPT ; eend $?
1770       fi
1771       eoutdent
1772     else
1773       einfo "Could not mount $MOUNTDEVICE to /mnt/grml - sorry." ; eend 1
1774     fi # mount $MOUNTDEVICE
1775    grep -q '/mnt/grml' /proc/mounts && umount /mnt/grml
1776  else
1777    einfo "Sorry, no device for bootoption myconfig provided. Skipping." ; eend 1
1778  fi # [ -n "$MOUNTDEVICE" ]
1779 fi # checkbootparam myconfig
1780
1781 if checkbootparam "partconf" ; then
1782  MOUNTDEVICE="$(getbootparam 'partconf' 2>>$DEBUG)"
1783  if [ -n "$MOUNTDEVICE" ]; then
1784    [ -d /mnt/grml ] || mkdir /mnt/grml
1785    mount -o ro -t auto $MOUNTDEVICE /mnt/grml ; RC="$?"
1786     if [[ $RC == 0 ]]; then
1787       einfo "Successfully mounted $MOUNTDEVICE to /mnt/grml (readonly)." ; eend 0
1788       einfo "Copying files from $MOUNTDEVICE over grml system."
1789       for file in `cat /etc/grml/partconf` ; do
1790         [ -d /mnt/grml/$file ] && cp -a /mnt/grml/${file}* ${file} && echo "copied: $file"
1791         [ -f /mnt/grml/$file ] && cp -a /mnt/grml/${file}  ${file} && echo "copied: $file"
1792       done && eend 0
1793     else
1794       einfo "Could not mount $MOUNTDEVICE to /mnt/grml - sorry." ; eend 1
1795     fi # mount $MOUNTDEVICE
1796    grep -q '/mnt/grml' /proc/mounts && umount /mnt/grml
1797  else
1798    einfo "Sorry, no device for bootoption partconf provided. Skipping." ; eend 1
1799  fi # [ -n "$MOUNTDEVICE" ]
1800 fi
1801 }
1802 # }}}
1803
1804 # {{{ /cdrom/.*-options
1805 config_debs(){
1806 if checkbootparam "debs" ; then
1807   DEBS="$(getbootparam 'debs' 2>>$DEBUG)"
1808   einfo "Tring to install debian package(s) ${DEBS}"
1809   dpkg -i /cdrom/debs/$DEBS* ; eend $?
1810 fi
1811 }
1812
1813 config_scripts(){
1814 if checkbootparam "scripts" ; then
1815   SCRIPTS="$(getbootparam 'scripts' 2>>$DEBUG)"
1816   [ -z "$SCRIPTS" ] && SCRIPTS='grml.sh'
1817   einfo "Bootparameter scripts found. Trying to execute ${SCRIPTS}:"
1818   sh -c /cdrom/scripts/$SCRIPTS ; eend $?
1819 fi
1820 }
1821 # }}}
1822
1823 # {{{ distcc
1824 config_distcc(){
1825 if checkbootparam "distcc" ; then
1826  OPTIONS="$(getbootparam distcc 2>>$DEBUG)"
1827  if [ -n "$OPTIONS" ]; then
1828     NET=""
1829     INTERFACE=""
1830     if [ -n "$OPTIONS" ]; then
1831       NET="${OPTIONS%%,*}"
1832       R="${OPTIONS#*,}"
1833       if [ -n "$R" -a "$R" != "$OPTIONS" ]; then
1834         OPTIONS="$R"
1835         INTERFACE="${OPTIONS%%,*}"
1836         R="${OPTIONS#*,}"
1837       fi
1838     fi
1839  fi
1840  CONFIG=/etc/default/distcc
1841  sed -i "s#^STARTDISTCC=.*#STARTDISTCC=YES#"  $CONFIG
1842  sed -i "s#^ALLOWEDNETS=.*#ALLOWEDNETS=$NET#" $CONFIG
1843
1844  if [ -n "$INTERFACE" ] ; then
1845    IP=$(LANG=C ifconfig $INTERFACE | gawk -F: /"inet addr"/'{print $2}' | gawk '{print $1}')
1846
1847    counter=10
1848    while [ -z "$IP" ] && [[ "$counter" != 0 ]] ; do
1849      counter=$(( counter-1 ))
1850      ewarn "No ip address for $INTERFACE found. Sleeping for 3 seconds. $counter tries left."
1851      sleep 3
1852      IP=$(LANG=C ifconfig $INTERFACE | gawk -F: /"inet addr"/'{print $2}' | gawk '{print $1}')
1853    done
1854  fi
1855
1856  if [ -n "$IP" ] ; then
1857    sed -i "s#^LISTENER=.*#LISTENER=$IP#"      $CONFIG
1858
1859    einfo "Bootoption distcc found. Preparing setup for distcc daemon."
1860    eindent
1861     id distccd >/dev/null 2>&1 || \
1862     (
1863       einfo "Creating distcc user" ; \
1864       adduser --quiet --system --ingroup nogroup --home / --no-create-home distccd ; eend $?
1865     )
1866
1867     einfo "Starting distcc for network ${NET}, listening on ${IP}."
1868    /etc/init.d/distcc start 1>/dev/null ; eend $?
1869    eoutdent
1870  else
1871    eerror "No ip address for $INTERFACE found. distcc can not be used without it." ; eend 1
1872  fi
1873 fi
1874
1875 if checkbootparam "gcc"; then
1876  GCC="$(getbootparam gcc 2>>$DEBUG)"
1877  eindent
1878  einfo "Pointing /usr/bin/gcc to /usr/bin/gcc-${GCC}."
1879  eoutdent
1880  rm -f /usr/bin/gcc
1881  ln -s /usr/bin/gcc-${GCC} /usr/bin/gcc ; eend $?
1882 fi
1883
1884 if checkbootparam "gpp"; then
1885  GPP="$(getbootparam gpp 2>>$DEBUG)"
1886  eindent
1887   einfo "Pointing /usr/bin/g++ to /usr/bin/g++-${GPP}."
1888   if [ -x /usr/bin/g++-${GPP} ] ; then
1889      rm -f /usr/bin/g++
1890      ln -s /usr/bin/g++-${GPP} /usr/bin/g++ ; eend $?
1891   fi
1892   einfo "Pointing /usr/bin/cpp to /usr/bin/cpp-${GPP}."
1893   if [ -x /usr/bin/cpp-${GPP} ] ; then
1894      rm -f /usr/bin/cpp
1895      ln -s /usr/bin/cpp-${GPP} /usr/bin/cpp ; eend $?
1896   fi
1897  eoutdent
1898 fi
1899
1900 }
1901 # }}}
1902
1903 # {{{ load modules
1904 # Notice: use it only on live-cd system, if running from harddisk please
1905 # add modules to /etc/modules and activate /etc/init.d/module-init-tools
1906 # in /etc/runlevel.conf
1907 config_modules(){
1908 MODULES_FILE=/etc/grml/modules
1909 if checkbootparam nomodules ; then
1910   ewarn "Skipping loading of modules defined in ${MODULES_FILE} as requested." ; eend 0
1911 elif [ -z "$INSTALLED" ]; then
1912  if [ -r $MODULES_FILE ] ; then
1913   einfo "Loading modules specified in ${MODULES_FILE}:"
1914   eindent
1915   grep '^[^#]' $MODULES_FILE | \
1916   while read module args; do
1917     [ "$module" ] || continue
1918       einfo "${module}"
1919       modprobe $module $args ; eend $?
1920   done
1921   eoutdent
1922  else
1923   ewarn "File $MODULES_FILE does not exist. Skipping loading of specific modules." ; eend 1
1924  fi
1925 fi
1926 }
1927 # }}}
1928
1929 # {{{ 915resolution
1930 config_915resolution(){
1931 if checkbootparam "915resolution" ; then
1932  OPTIONS="$(getbootparam 915resolution 2>>$DEBUG)"
1933   if [ -x /usr/sbin/915resolution ]; then
1934     CMD=915resolution
1935     MODE=""
1936     XRESO=""
1937     YRESO=""
1938     if [ -n "$OPTIONS" ]; then
1939       # Extra options
1940       MODE="${OPTIONS%%,*}"
1941       R="${OPTIONS#*,}"
1942       if [ -n "$R" -a "$R" != "$OPTIONS" ]; then
1943         OPTIONS="$R"
1944         XRESO="${OPTIONS%%,*}"
1945         R="${OPTIONS#*,}"
1946         if [ -n "$R" -a "$R" != "$OPTIONS" ]; then
1947           OPTIONS="$R"
1948           YRESO="${OPTIONS%%,*}"
1949           R="${OPTIONS#*,}"
1950         fi
1951       fi
1952     fi
1953     einfo "Running 915resolution with options ${MODE} ${XRESO} ${YRESO}."
1954     [ -n "$MODE" ] && [ -n "$XRESO"  ] && [ -n "$YRESO" ]  && ( sh -c "$CMD $MODE $XRESO $YRESO" & )
1955     eend 0
1956   fi
1957 fi
1958 }
1959 # }}}
1960
1961 # {{{ SW-RAID
1962 config_swraid(){
1963   if [ -z "$INSTALLED" ] ; then
1964   # notice: checkbootparam "forensic" is just for users who don't know how to really use the bootoption
1965   if checkbootparam 'noraid'   -o checkbootparam 'noswraid' -o \
1966      checkbootparam 'forensic' -o checkbootparam 'raid=noautodetect' ; then
1967      ewarn "Skipping SW-RAID code as requested on boot commandline." ; eend 0
1968   else
1969     if ! [ -x /sbin/mdadm ] ; then
1970        eerror "mdadm not available, can not execute it." ; eend 1
1971     else
1972
1973        # if ! egrep -qv '^(MAILADDR.*|#.*|)$' /etc/mdadm/mdadm.conf 2>>$DEBUG ; then
1974        # find out whether we have a valid configuration file already
1975        if ! grep -q ARRAY /etc/mdadm/mdadm.conf 2>>$DEBUG ; then
1976           einfo "Creating /etc/mdadm/mdadm.conf for use with mdadm."
1977           [ -r /etc/mdadm/mdadm.conf ] && mv /etc/mdadm/mdadm.conf /etc/mdadm/mdadm.conf.old
1978           MDADM_MAILADDR__='root' /usr/share/mdadm/mkconf > /etc/mdadm/mdadm.conf ; eend $?
1979         else
1980           ewarn "/etc/mdadm/mdadm.conf looks like a configured mdadm setup, will not touch it." ; eend 0
1981        fi
1982
1983        if ! checkbootparam 'swraid' ; then
1984           eindent
1985           einfo "Just run 'Start mdadm-raid' to assemble md arrays or boot using 'swraid' as bootoption for autostart."
1986           eoutdent
1987        else
1988           einfo "Bootoption swraid found. Searching for software RAID arrays:"
1989           eindent
1990            IFSOLD=${IFS:-}
1991            IFS='
1992 '
1993            for line in $(mdadm --assemble --scan --auto=yes --symlink=no 2>&1) ; do
1994                case $line in
1995                  *'No arrays found'*)
1996                    ewarn "$line" ; eend 0
1997                    ;;
1998                  *)
1999                    einfo "$line" ; eend 0
2000                    ;;
2001                esac
2002            done
2003            IFS=$IFSOLD
2004          eoutdent
2005
2006          if [ -r /proc/mdstat ] ; then
2007             eindent
2008             MDSTAT=$(grep '^md[0-9]' /proc/mdstat)
2009             if [ -z "$MDSTAT" ] ; then
2010                ewarn "No active arrays found" ; eend 0
2011             else
2012                IFSOLD=${IFS:-}
2013                IFS='
2014 '
2015                for line in $(grep '^md[0-9]' /proc/mdstat) ; do
2016                    einfo "active arrays: $line" ; eend 0
2017                done
2018                IFS=$IFSOLD
2019             fi
2020             eoutdent
2021          fi # /proc/mdstat
2022        fi # bootoption swraid
2023
2024      fi # is /sbin/mdadm executable?
2025   fi # check for bootoptions
2026   fi # run only in live-cd mode
2027 }
2028 # }}}
2029
2030 # {{{ debnet: setup network based on an existing one found on a partition
2031 config_debnet(){
2032 if checkbootparam "debnet" ; then
2033  iszsh && setopt shwordsplit
2034  DEVICES="$(< /proc/partitions tail -n +3 | awk '{print "/dev/"$4}' | tr "\n" " ")"
2035  DEVICES="$DEVICES $(ls /dev/mapper/*)"
2036  FOUND_DEBNET=""
2037
2038  einfo "Bootoption 'debnet' found. Searching for Debian network configuration: "
2039  eindent
2040  if ! mount | grep '/mnt ' 1>/dev/null 2>&1 ; then
2041     for i in $DEVICES; do
2042      if mount -o ro -t auto "$i" /mnt >/dev/null 2>&1; then
2043          einfo "Scanning on $i"
2044        if [ -f /mnt/etc/network/interfaces ]; then
2045          einfo "/etc/network/interfaces found on ${i}" ; eend 0
2046          FOUND_DEBNET="$i"
2047          break
2048        fi
2049        umount /mnt
2050      fi
2051     done
2052
2053    if [ -n "$FOUND_DEBNET" ]; then
2054      einfo "Stopping network."
2055        pump -k 1>/dev/null 2>&1
2056        /etc/init.d/networking stop 1>/dev/null 2>&1 ; eend $?
2057      einfo "Copying Debian network configuration from $FOUND_DEBNET to running system."
2058        rm -rf /etc/network/run
2059        cp -a /mnt/etc/network /etc
2060        rm -rf /etc/network/run
2061        mkdir /etc/network/run
2062        umount /mnt ; eend $?
2063      einfo "Starting network."
2064        /etc/init.d/networking start ; eend $?
2065    else
2066      eerror "/etc/network/interfaces not found." ; eend 1
2067    fi
2068    eoutdent
2069  else
2070   eerror "Error: /mnt already mounted." ; eend 1
2071  fi
2072 fi
2073 }
2074 # }}}
2075
2076 # {{{ disable console blanking
2077 config_blanking(){
2078 if checkbootparam "noblank" ; then
2079   einfo "Bootoption noblank found. Disabling monitor blanking."
2080   setterm -blank 0 ; eend $?
2081 fi
2082 }
2083 # }}}
2084
2085 # {{{ grml2hd: automatic installation
2086 config_grml2hd(){
2087
2088 if checkbootparam "user" ; then
2089   NEWUSER=''
2090   NEWUSER="$(getbootparam 'user' 2>>$DEBUG)"
2091   sed -i "s/^NEWUSER=.*/NEWUSER=$NEWUSER/" /etc/grml2hd/config || export GRML2HD_FAIL=1
2092 fi
2093
2094 if checkbootparam "filesystem" ; then
2095   FILESYSTEM=''
2096   FILESYSTEM="$(getbootparam 'filesystem' 2>>$DEBUG)"
2097   sed -i "s/^FILESYSTEM=.*/FILESYSTEM=$FILESYSTEM/" /etc/grml2hd/config || export GRML2HD_FAIL=1
2098 fi
2099
2100 if checkbootparam "partition" ; then
2101   PARTITION=''
2102   PARTITION="$(getbootparam 'partition' 2>>$DEBUG)"
2103   # notice: the following checks whether the given partition is available, if not the skip
2104   # execution of grml2hd as it might result in data loss...
2105   if [ -r $PARTITION ] ; then
2106     sed -i "s#^PARTITION=.*#PARTITION=$PARTITION#" /etc/grml2hd/config || export GRML2HD_FAIL=1
2107   else
2108     ewarn "Partition $PARTITION does not exist. Skipping execution of grml2hd therefore." ; eend 1
2109   fi
2110 fi
2111
2112 if checkbootparam "mbr" ; then
2113   BOOT_PARTITION=''
2114   BOOT_PARTITION="$(getbootparam 'mbr' 2>>$DEBUG)"
2115   sed -i "s#^BOOT_PARTITION=.*#BOOT_PARTITION=$BOOT_PARTITION#" /etc/grml2hd/config || export GRML2HD_FAIL=1
2116 fi
2117
2118 if stringinstring "BOOT_IMAGE=grml2hd " "$CMDLINE" ; then
2119   cat>|/usr/bin/grml2hd_noninteractive<<EOF
2120 #!/bin/sh
2121 GRML2HD_NONINTERACTIVE='yes' grml2hd
2122 EOF
2123   chmod 755 /usr/bin/grml2hd_noninteractive
2124   einfo "Bootparameter grml2hd found. Running automatic installation via grml2hd using /etc/grml2hd/config." && eend 0
2125   if [ -z "$GRML2HD_FAIL" ] ; then
2126     screen /usr/bin/grml2hd_noninteractive ; einfo "Invoking a shell, just exit to continue booting..." ; /bin/zsh
2127   else
2128     ewarn "There was an error adjusting /etc/grml2hd/config. Skipping execution of grml2hd for security reasons." ; eend 1
2129   fi
2130 fi
2131 }
2132 # }}}
2133
2134 # {{{ Support customization
2135 config_distri(){
2136 if checkbootparam "distri"; then
2137   DISTRI="$(getbootparam 'distri' 2>>$DEBUG)"
2138   if [ -r /cdrom/desktop/"$DISTRI".jpg ] ; then
2139      [ -n "$BOOTDEBUG" ] && einfo "Debug: bootoption distri found and file /cdrom/desktop/$DISTRI present" && eend 0
2140      cp /cdrom/desktop/"$DISTRI".jpg /usr/share/grml/desktop.jpg
2141   fi
2142 fi
2143 }
2144 # }}}
2145
2146 ### {{{ backwards compatible stuff
2147 config_environment(){
2148   ewarn "config_environment is deprecated. Please set CONFIG_ENVIRONMENT in /etc/grml/autoconfig to 'no'." ; eend 0
2149 }
2150 config_keyboard(){
2151   ewarn "config_keyboard is deprecated. Please set CONFIG_KEYBOARD in /etc/grml/autoconfig to 'no'." ; eend 0
2152 }
2153 # }}}
2154
2155 ## END OF FILE #################################################################
2156 # vim:foldmethod=marker